#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <error.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <linux/loop.h>

extern const char *__progname;

int main(int argc, char **argv)
{
    const char *device_path = NULL;
    const char *storage_path = NULL;
    int device_fd = -1;
    int storage_fd = -1;

    if (argc < 3) {
	fprintf(stderr, "Usage: %s <loop-device> <new storage>\n", __progname);
	return EXIT_FAILURE;
    }
    device_path = argv[1];
    storage_path = argv[2];

    if ((device_fd = open(device_path,O_RDONLY)) <= 0)
	error(EXIT_FAILURE,errno,"open device '%s'",device_path);

    if ((storage_fd = open(storage_path,O_RDONLY)) <= 0)
	error(EXIT_FAILURE,errno,"open storage '%s'",storage_path);

    if (ioctl(device_fd, (unsigned long int)LOOP_CHANGE_FD,storage_fd))
	error(EXIT_FAILURE,errno,"loop change fd");
    
    return EXIT_SUCCESS;
}
